Index: kernel/generic/src/adt/avl.c
===================================================================
--- kernel/generic/src/adt/avl.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/adt/avl.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup kernel_generic_adt
  * @{
  */
Index: kernel/generic/src/adt/bitmap.c
===================================================================
--- kernel/generic/src/adt/bitmap.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/adt/bitmap.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup kernel_generic_adt
  * @{
  */
Index: kernel/generic/src/adt/btree.c
===================================================================
--- kernel/generic/src/adt/btree.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/adt/btree.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup kernel_generic_adt
  * @{
  */
Index: kernel/generic/src/adt/cht.c
===================================================================
--- kernel/generic/src/adt/cht.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/adt/cht.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup kernel_generic_adt
  * @{
  */
Index: kernel/generic/src/adt/list.c
===================================================================
--- kernel/generic/src/adt/list.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/adt/list.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericadt
+/** @addtogroup kernel_generic_adt
  * @{
  */
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/cap/cap.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/console/chardev.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericconsole
+/** @addtogroup kernel_generic_console
  * @{
  */
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/console/cmd.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericconsole
+/** @addtogroup kernel_generic_console
  * @{
  */
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/console/console.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericconsole
+/** @addtogroup kernel_generic_console
  * @{
  */
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/console/kconsole.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericconsole
+/** @addtogroup kernel_generic_console
  * @{
  */
Index: kernel/generic/src/console/prompt.c
===================================================================
--- kernel/generic/src/console/prompt.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/console/prompt.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericconsole
+/** @addtogroup kernel_generic_console
  * @{
  */
Index: kernel/generic/src/cpu/cpu.c
===================================================================
--- kernel/generic/src/cpu/cpu.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/cpu/cpu.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/cpu/cpu_mask.c
===================================================================
--- kernel/generic/src/cpu/cpu_mask.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/cpu/cpu_mask.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/ddi/ddi.c
===================================================================
--- kernel/generic/src/ddi/ddi.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ddi/ddi.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericddi
+/** @addtogroup kernel_generic_ddi
  * @{
  */
Index: kernel/generic/src/ddi/irq.c
===================================================================
--- kernel/generic/src/ddi/irq.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ddi/irq.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericddi
+/** @addtogroup kernel_generic_ddi
  * @{
  */
Index: kernel/generic/src/debug/debug.c
===================================================================
--- kernel/generic/src/debug/debug.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/debug/debug.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericdebug
+/** @addtogroup kernel_generic_debug
  * @{
  */
Index: kernel/generic/src/debug/panic.c
===================================================================
--- kernel/generic/src/debug/panic.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/debug/panic.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericdebug
+/** @addtogroup kernel_generic_debug
  * @{
  */
Index: kernel/generic/src/debug/stacktrace.c
===================================================================
--- kernel/generic/src/debug/stacktrace.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/debug/stacktrace.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericdebug
+/** @addtogroup kernel_generic_debug
  * @{
  */
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/debug/symtab.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericdebug
+/** @addtogroup kernel_generic_debug
  * @{
  */
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/interrupt/interrupt.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericinterrupt
+/** @addtogroup kernel_generic_interrupt
  * @{
  */
Index: kernel/generic/src/ipc/event.c
===================================================================
--- kernel/generic/src/ipc/event.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/event.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ipc.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ipcrsc.c
===================================================================
--- kernel/generic/src/ipc/ipcrsc.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ipcrsc.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/irq.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/kbox.c
===================================================================
--- kernel/generic/src/ipc/kbox.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/kbox.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/conctmeto.c
===================================================================
--- kernel/generic/src/ipc/ops/conctmeto.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/conctmeto.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/concttome.c
===================================================================
--- kernel/generic/src/ipc/ops/concttome.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/concttome.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/dataread.c
===================================================================
--- kernel/generic/src/ipc/ops/dataread.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/dataread.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/datawrite.c
===================================================================
--- kernel/generic/src/ipc/ops/datawrite.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/datawrite.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/debug.c
===================================================================
--- kernel/generic/src/ipc/ops/debug.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/debug.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/pagein.c
===================================================================
--- kernel/generic/src/ipc/ops/pagein.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/pagein.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/sharein.c
===================================================================
--- kernel/generic/src/ipc/ops/sharein.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/sharein.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/shareout.c
===================================================================
--- kernel/generic/src/ipc/ops/shareout.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/shareout.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/ops/stchngath.c
===================================================================
--- kernel/generic/src/ipc/ops/stchngath.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/ops/stchngath.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/sysipc.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/ipc/sysipc_ops.c
===================================================================
--- kernel/generic/src/ipc/sysipc_ops.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/ipc/sysipc_ops.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericipc
+/** @addtogroup kernel_generic_ipc
  * @{
  */
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/elf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/gsort.c
===================================================================
--- kernel/generic/src/lib/gsort.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/gsort.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/halt.c
===================================================================
--- kernel/generic/src/lib/halt.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/halt.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/mem.c
===================================================================
--- kernel/generic/src/lib/mem.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/mem.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/memfnc.c
===================================================================
--- kernel/generic/src/lib/memfnc.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/memfnc.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/ra.c
===================================================================
--- kernel/generic/src/lib/ra.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/ra.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/lib/rd.c
===================================================================
--- kernel/generic/src/lib/rd.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/rd.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/lib/str.c
===================================================================
--- kernel/generic/src/lib/str.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/lib/str.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/log/log.c
===================================================================
--- kernel/generic/src/log/log.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/log/log.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/as.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/backend_anon.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/backend_elf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/backend_phys.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/backend_user.c
===================================================================
--- kernel/generic/src/mm/backend_user.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/backend_user.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/frame.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -29,5 +29,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/km.c
===================================================================
--- kernel/generic/src/mm/km.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/km.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/page.c
===================================================================
--- kernel/generic/src/mm/page.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/page.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/reserve.c
===================================================================
--- kernel/generic/src/mm/reserve.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/reserve.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/slab.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/mm/tlb.c
===================================================================
--- kernel/generic/src/mm/tlb.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/mm/tlb.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericmm
+/** @addtogroup kernel_generic_mm
  * @{
  */
Index: kernel/generic/src/preempt/preemption.c
===================================================================
--- kernel/generic/src/preempt/preemption.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/preempt/preemption.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/printf/printf.c
===================================================================
--- kernel/generic/src/printf/printf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/printf/printf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/printf/printf_core.c
===================================================================
--- kernel/generic/src/printf/printf_core.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/printf/printf_core.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -29,5 +29,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/printf/snprintf.c
===================================================================
--- kernel/generic/src/printf/snprintf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/printf/snprintf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/printf/vprintf.c
===================================================================
--- kernel/generic/src/printf/vprintf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/printf/vprintf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/printf/vsnprintf.c
===================================================================
--- kernel/generic/src/printf/vsnprintf.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/printf/vsnprintf.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/proc/program.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup genericproc
+/** @addtogroup kernel_generic_proc
  * @{
  */
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/proc/scheduler.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericproc
+/** @addtogroup kernel_generic_proc
  * @{
  */
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/proc/task.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericproc
+/** @addtogroup kernel_generic_proc
  * @{
  */
Index: kernel/generic/src/proc/the.c
===================================================================
--- kernel/generic/src/proc/the.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/proc/the.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericproc
+/** @addtogroup kernel_generic_proc
  * @{
  */
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/proc/thread.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genericproc
+/** @addtogroup kernel_generic_proc
  * @{
  */
Index: kernel/generic/src/security/perm.c
===================================================================
--- kernel/generic/src/security/perm.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/security/perm.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/smp/ipi.c
===================================================================
--- kernel/generic/src/smp/ipi.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/smp/ipi.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/smp/smp.c
===================================================================
--- kernel/generic/src/smp/smp.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/smp/smp.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/smp/smp_call.c
===================================================================
--- kernel/generic/src/smp/smp_call.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/smp/smp_call.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/synch/smp_memory_barrier.c
===================================================================
--- kernel/generic/src/synch/smp_memory_barrier.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/synch/smp_memory_barrier.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/synch/workqueue.c
===================================================================
--- kernel/generic/src/synch/workqueue.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/synch/workqueue.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/syscall/copy.c
===================================================================
--- kernel/generic/src/syscall/copy.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/syscall/copy.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/syscall/syscall.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/sysinfo/stats.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/udebug/udebug.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision 10d65d70906a865fb116576edc88e47ab61a5fb4)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 174156fd1cf321a6363777352073d05829467b2f)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup kernel_generic
  * @{
  */